SystemOrganization addCategory: #'AL-Postgres'!

Notification subclass: #ALPgConnectionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Postgres'!

ALRelay subclass: #ALPgPoolRelay
	instanceVariableNames: 'args idle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Postgres'!

!ALPgPoolRelay class methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:41'!
destination: aRelay connectionArgs: aPGConnectionArgs
	^ self basicNew initializeWithDestination: aRelay connectionArgs: aPGConnectionArgs
		! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:14'!
committing: aBoolean do: aBlock 
	| connection sql |
	connection := nil.
	sql := aBoolean ifTrue: ['COMMIT'] ifFalse: ['ROLLBACK'].
	^ [aBlock
		on: ALPgConnectionRequest
		do: 	[:notification | 
			connection ifNil: [connection := self reserveConnection].
			connection executeAndCheckResult: 'BEGIN'.
			notification resume: connection]] 
				ensure:
					[connection ifNotNil: 
						[connection executeAndCheckResult: sql.
						self releaseConnection: connection]]
			! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:15'!
handleRequest: aRequest
	^ self committing: true do: [destination handleRequest: aRequest]! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:42'!
initializeWithDestination: aRelay connectionArgs: aPGConnectionArgs
	self initializeWithDestination: aRelay.
	args := aPGConnectionArgs.
	idle := IdentitySet new.
	! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:10'!
releaseConnection: aPGConnection
	idle add: aPGConnection! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:09'!
reserveConnection
	^ idle isEmpty
		ifFalse: [idle remove: idle anyOne]
		ifTrue: 
			[PGConnection new
				connectionArgs: args;
				startup;
				yourself]
	! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:16'!
write: aMessage into: aWriteStream
	^ self committing: false do: [destination write: aMessage into: aWriteStream]! !
